/************************************
***			          ***
***       Binary Diff v1.1        ***
***       =========== ====        ***
***			          ***
***  (c) 22.2.91 by Andreas Ley   ***
***			          ***
***  (u) 15.6.2016                ***
***			          ***
************************************/

char header[]="Binary Diff v1.1\n(c) 1991-2016 by Andreas Ley\n";

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

#ifdef vms
#include "getopt.c"
#endif /* vms */

#define	screen(c)	(((c)&0x7f)<0x20?'.':(c))


void bdiff(src1,src2,loc)
FILE *src1,*src2;
long loc;
{
  unsigned char	c1,c2;

  while (!feof(src1) && !feof(src2)) {
    c1=fgetc(src1);
    c2=fgetc(src2);
    if (c1!=c2)
      printf("%06lx: %02x %c %02x %c\n",loc,c1,screen(c1),c2,screen(c2));
    loc++;
  }
  if (!feof(src1))
    printf("First file is longer than second file.\n");
  if (!feof(src2))
    printf("Second file is longer than first file.\n");
}



void usage(image)
char *image;
{
  fprintf(stderr,"Usage: %s [-s skip] file1 file2\n",image);
  exit(1);
}



int main(argc,argv)
int argc;
char *argv[];
{
  int		c;
  extern char	*optarg;
  extern int	optind;
  long		skip=0;
  FILE		*src1,*src2;

  while ((c=getopt(argc,argv,"s:h?")) != EOF)
    switch ((char)c) {
      case 's': skip=atoi(optarg);
      		break;
      case 'h': fprintf(stderr,"%s",header);
      case '?': usage(argv[0]);
    }

  if (optind!=argc-2)
    usage(argv[0]);

  if ((src1=fopen(argv[optind],"r"))) {
    if (fseek(src1,skip,SEEK_SET)) {
      fprintf(stderr,"Unable to skip %06lx bytes of ",skip);
      perror(argv[optind]);
    }
    else {
      if ((src2=fopen(argv[optind+1],"r"))) {
        if (fseek(src2,skip,SEEK_SET)) {
          fprintf(stderr,"Unable to skip %06lx bytes of ",skip);
          perror(argv[optind+1]);
        }
        else {
          bdiff(src1,src2,skip);
        }
        fclose(src2);
      }
      else {
        fprintf(stderr,"Unable to open ");
        perror(argv[optind+1]);
      }
    }
    fclose(src1);
  }
  else {
    fprintf(stderr,"Unable to open '%s'\n",argv[optind]);
    perror(argv[optind]);
  }
}
